Debian Bug report logs - #734188
ITP: folly -- library of C++11 components designed with practicality and efficiency in mind

Package: wnpp; Maintainer for wnpp is wnpp@debian.org;

Reported by: "Laszlo Boszormenyi (GCS)" <gcs@debian.org>

Date: Sat, 4 Jan 2014 17:21:18 UTC

Owned by: Laszlo Boszormenyi (GCS) <gcs@debian.org>

Severity: wishlist

Tags: pending, upstream, wontfix

Reply or subscribe to this bug.

Toggle useless messages

View this report as an mbox folder, status mbox, maintainer mbox


Report forwarded to debian-bugs-dist@lists.debian.org, wnpp@debian.org, Laszlo Boszormenyi (GCS) <gcs@debian.org>:
Bug#734188; Package wnpp. (Sat, 04 Jan 2014 17:21:22 GMT) Full text and rfc822 format available.

Acknowledgement sent to "Laszlo Boszormenyi (GCS)" <gcs@debian.org>:
New Bug report received and forwarded. Copy sent to wnpp@debian.org, Laszlo Boszormenyi (GCS) <gcs@debian.org>. (Sat, 04 Jan 2014 17:21:22 GMT) Full text and rfc822 format available.

Message #5 received at submit@bugs.debian.org (full text, mbox):

From: "Laszlo Boszormenyi (GCS)" <gcs@debian.org>
To: Debian Bug Tracking System <submit@bugs.debian.org>
Subject: ITP: folly -- library of C++11 components designed with practicality and efficiency in mind
Date: Sat, 04 Jan 2014 18:20:19 +0100
Package: wnpp
Severity: wishlist
Owner: Laszlo Boszormenyi (GCS) <gcs@debian.org>

* Package name    : folly
  Version         : git snapshot
  Upstream Author : Facebook, Inc.
* URL             : https://github.com/facebook/folly
* License         : Apache-2.0
  Programming Lang: C++
  Description     : library of C++11 components designed with practicality and efficiency in mind
 
 It complements (as opposed to competing against) offerings such as Boost
 and of course std. In fact, we embark on defining our own component only
 when something we need is either not available, or does not meet the needed
 performance profile.
 Performance concerns permeate much of Folly, sometimes leading to designs
 that are more idiosyncratic than they would otherwise be (see e.g.
 PackedSyncPtr.h, SmallLocks.h). Good performance at large scale is a
 unifying theme in all of Folly.




Information forwarded to debian-bugs-dist@lists.debian.org, wnpp@debian.org, Laszlo Boszormenyi (GCS) <gcs@debian.org>:
Bug#734188; Package wnpp. (Sat, 04 Jan 2014 18:54:04 GMT) Full text and rfc822 format available.

Acknowledgement sent to Faidon Liambotis <paravoid@debian.org>:
Extra info received and forwarded to list. Copy sent to wnpp@debian.org, Laszlo Boszormenyi (GCS) <gcs@debian.org>. (Sat, 04 Jan 2014 18:54:04 GMT) Full text and rfc822 format available.

Message #10 received at 734188@bugs.debian.org (full text, mbox):

From: Faidon Liambotis <paravoid@debian.org>
To: László Böszörményi (GCS) <gcs@debian.org>
Cc: Paul Tarjan <pt@fb.com>, 727085@bugs.debian.org, 734188@bugs.debian.org
Subject: Re: Bug#727085: Now we don't depend on the weird libevent patch
Date: Sat, 4 Jan 2014 20:28:24 +0200
On Sat, Jan 04, 2014 at 07:07:15PM +0100, László Böszörményi (GCS) wrote:
>> Does folly have a stable ABI? I remember raising this with Paul some 
>> time
>> ago and us deciding that embedding folly into the HHVM source would be the
>> way to go, as there is really no stable interface between them.
> I can't answer this question. Still, I expect that HHVM will follow
>ABI changes very fast. Paul?
>Anyway, I think having a separate package and let users get knowledge
>of that doesn't mean HHVM can't use an embedded copy if it needs to.
>But it should be a separate package whenever it's possible.

If the ABI isn't stable, HHVM is the least of your problems. Non ABI 
stable libraries have really no place in Debian: you have to bump the 
SONAME, rename the package, go through NEW, binNMU all reverse 
dependencies, go through a testing transition etc. every time and that's 
*if* you detect the ABI breakage and it doesn't get silently undetected 
crashing reverse dependencies (= RC bug).

Check with your upstream (Paul? someone else?) if they're guranteeing 
ABI, and preferrably also tag versions rather than packaging random git 
snapshots, *then* upload it. Otherwise it's a pretty pointless exercise 
and I'm sure it'll get REJECTed from NEW.

For HHVM, embedding the folly source as the upstream build does seems 
like the best course of action to me, especially since folly isn't a 
library that we expect to see wide adoption for other packages out 
there.

>> Also, you're really supposed to file separate ITPs for separate packages
>> (and file them *before* you make an upload).
> ??? Please see its ITP[1]. I just noted the upload here. It's closed
>by the changelog in the folly package if that will be accepted into
>the archive.

The reason ITPs exist and policy mandates that they are Cc'ed to 
debian-devel is so that all developers have a chance to raise issues 
(such as naming conflicts, ABI stability, package descriptions, previous 
work etc.).  Filing the ITP and uploading <= 30mins later is a really 
bad practice and doesn't really count, it feels like working around 
Policy to me. (it also hasn't even reached my debian-devel inbox yet, 
did you X-Debbugs-Cc it?)[1]

Regards,
Faidon

1: You're not the first person that I've told that :) cf.  
https://lists.debian.org/debian-devel/2013/06/msg00666.html



Added tag(s) pending. Request was from Anibal Monsalve Salazar <anibal@debian.org> to control@bugs.debian.org. (Sat, 04 Jan 2014 19:06:13 GMT) Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, wnpp@debian.org, Laszlo Boszormenyi (GCS) <gcs@debian.org>:
Bug#734188; Package wnpp. (Mon, 06 Jan 2014 09:15:11 GMT) Full text and rfc822 format available.

Acknowledgement sent to László Böszörményi (GCS) <gcs@debian.org>:
Extra info received and forwarded to list. Copy sent to wnpp@debian.org, Laszlo Boszormenyi (GCS) <gcs@debian.org>. (Mon, 06 Jan 2014 09:15:11 GMT) Full text and rfc822 format available.

Message #17 received at 734188@bugs.debian.org (full text, mbox):

From: László Böszörményi (GCS) <gcs@debian.org>
To: Debian FTP Masters <ftpmaster@ftp-master.debian.org>, 734188@bugs.debian.org
Cc: Sara Golemon <SaraMG@fb.com>, Jordan DeLong <delong.j@fb.com>, Paul Tarjan <pt@fb.com>, Faidon Liambotis <paravoid@debian.org>, "727085@bugs.debian.org" <727085@bugs.debian.org>
Subject: Re: Bug#727085: Now we don't depend on the weird libevent patch
Date: Mon, 6 Jan 2014 10:12:13 +0100
Hi FTP Masters,

Folly is part of HHVM[1] and both used inside Facebook. I wanted a
separate package that HHVM would depend on. With the collate below
with FB developers, I realized it doesn't stand on its own. Please
reject it from the NEW queue.
HHVM will contain the Folly git snapshot that works for them. Neither
the best path, but I do hope it will be mature with time. I will
package it then.

Thanks and sorry for the noise.
Laszlo/GCS
[1] http://www.hhvm.com/blog/

On Sun, Jan 5, 2014 at 4:44 AM, Jordan DeLong <delong.j@fb.com> wrote:
> On Sat, Jan 04, 2014 at 11:53:25PM +0100, László Böszörményi (GCS) wrote:
>> Question is, does Folly maintain ABI compatibility? If it changes
>> from time-to-time, how often?
>
> Yeah, it doesn't attempt to maintain ABI backward compatability, and
> we haven't done much about tracking when we break source-level
> backward compatability either.  (As Sara said, we don't version it
> currently... unless you count the submodule in hhvm ;)
>
> There are changes probably a few times a week, although I'd suspect
> few of the changes that aren't to new components (usually in
> folly/experimental) actually break source backward compat.
>
> I do think it'd be nice to have folly packages some day, but mostly
> the value there would be making it easier to use folly (in other C++
> projects).  I don't think it's going to be all that helpful for people
> who just want to use hhvm: it's largely a header-only library, so even
> if there are nice folly-dev packages with .h's and .a's, I'd hope a
> pre-built hhvm package wouldn't depend on a folly package being
> installed, since it makes more sense to statically link it.
>
> (Actually there's probably not much point to having a non-development
> folly package containing .so's for most reasonable use cases w/ the
> library as it is today---maybe if it grows significantly in the
> non-header-only portion in the future, but probably not anytime soon.)



Information forwarded to debian-bugs-dist@lists.debian.org, wnpp@debian.org, Laszlo Boszormenyi (GCS) <gcs@debian.org>:
Bug#734188; Package wnpp. (Mon, 06 Jan 2014 10:39:09 GMT) Full text and rfc822 format available.

Acknowledgement sent to László Böszörményi (GCS) <gcs@debian.org>:
Extra info received and forwarded to list. Copy sent to wnpp@debian.org, Laszlo Boszormenyi (GCS) <gcs@debian.org>. (Mon, 06 Jan 2014 10:39:10 GMT) Full text and rfc822 format available.

Message #22 received at 734188@bugs.debian.org (full text, mbox):

From: László Böszörményi (GCS) <gcs@debian.org>
To: Debian Bug Tracking System <control@bugs.debian.org>
Cc: 734188@bugs.debian.org
Subject: Folly shouldn't be packaged for now
Date: Mon, 6 Jan 2014 11:36:25 +0100
tags 734188 + wontfix upstream
thanks

Needs at least a constant ABI from upstream. Then HHVM may (build) depend on it.



Added tag(s) upstream and wontfix. Request was from László Böszörményi (GCS) <gcs@debian.org> to control@bugs.debian.org. (Mon, 06 Jan 2014 10:39:13 GMT) Full text and rfc822 format available.

Send a report that this bug log contains spam.


Debian bug tracking system administrator <owner@bugs.debian.org>. Last modified: Wed Apr 23 19:06:28 2014; Machine Name: buxtehude.debian.org

Debian Bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997,2003 nCipher Corporation Ltd, 1994-97 Ian Jackson.